
using CpuId
using Libdl

## this lets us load CpuId only once 

if cpufeature(:AVX2)
    libsuffix = :avx2
    println("AVX2 support detected, vml_avx2 selected")
else
    libsuffix = :avx
    println("AVX2 support missing, vml_avx selected")
end

if Sys.iswindows()
    rtlib = :mkl_rt
    corelib = :mkl_core
    lib = Symbol(:mkl_vml_, libsuffix)
else
    rtlib = :libmkl_rt
    corelib = :libmkl_core
    lib = Symbol(:libmkl_vml_, libsuffix)
end


depsjl_path = joinpath(@__DIR__, "deps.jl")
open(depsjl_path, "w") do depsjl_file
    println(depsjl_file, strip("""
        ## This file was autogenerated by build.jl.
        ## Do not edit.
        import Libdl

        const lib = :$lib
        const rtlib = :$rtlib
        const corelib = :$corelib
        """))
end
